/****************************************************************************
   This is a part of programm of Dictionary for UNIX
   Copyright (C) 1999 Anisimow Dmitry.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/
# include <stdio.h>
# include <malloc.h>
# include <string.h>
# include <stdlib.h>
# include <dirent.h>
# include <sys/types.h>
# include <sys/stat.h>

# include <mylib.h>
# include <t_schone.h>
# include <menu.h>
# include <slowo.h>

# define min(a,b) (((a)<(b)) ? (a) : (b))
# define max(a,b) (((a)>(b)) ? (a) : (b))

struct t_TextStande
{  char color ; };    // 梥

struct t_DictStande
{  t_TextStande Text[5] ;
   char  Divider[10] ; // ࠧ⥫
   char  fTrans ;      // 㤥  ࠭ਯ
};

struct t_Stande1
{
   char          Path[200] ;
   char          Geometry[20] ;
   t_DictStande *Dict ;
   short         n_Dict ;
   void          init( void );
   char          read1( void );
   void          read2( void );   
   void          write( void );
};

t_Stande1 Stande1 ;

/****************************************************************************/
char   StartPath[200]; // ⠫,   ᫮
char   Sempty[256] ;   //  ப
char  *StrExit="Exit";

short  px=0 ;          // न 
short  max_X,max_Y ;   // ࠧ ନ쭮 

t_WorterBuch Buch ;

void  main_loop( void );
void  malen( short i_wort,char *Str );
void  antwort( long i_wort );
void  malen1( long i_wort, short x, short y );
void  init_dic_menu( void );
void  init_buch( void );
void  read_buch( void *Str );
void  f_exit( void *V );

void   set_path( int argc, char *argv[] );
int    load_rcfile( char* rcfile_name, char* cgi_type  );
char  *get_value( char* name );
short  tcolor( char *str );
/***************************************************************************/

/***************************************************************************/
int main( int argc, char *argv[] )
{  short i ;
   char  r ;

	s_begin_schone( argc, argv );
	memset( Sempty, ' ' , sizeof( Sempty ));

// it's code for ram only (fuck)
//   for( i=0 ; i<255 ; i++ )
//      Sempty[i]=' ';
//   Sempty[255]=0 ;

	Sempty[sizeof(Sempty)-1]='\0' ;

   r=Stande1.read1( );
   set_path( argc, argv );   

   init_buch( StartPath );
   init_dic_menu( );
   
   Stande1.init( );
   if( r<0 ) Stande1.write( );
       else  Stande1.read2( );
   read_buch( file_menu_r[0].data );
   main_loop();
   return 0 ;
}
/***************************************************************************/
void set_path( int argc, char *argv[] )
{  short i ;

   for( i=1 ; i<argc-1 ; i++ )
      if( 0==strcmp(argv[i],"-path") )
      {   strcpy( StartPath,argv[i+1] ) ;
          if( StartPath[strlen(StartPath)-1]!='/' )
	      strcat( StartPath,"/" );
	  break ;
      }
}
/***************************************************************************/
void init_dic_menu( void )
{  short i ;

   file_menu_r=(struct MENU *)Calloc( n_Files+2,sizeof(struct MENU) );
   wort_menu_r[0].next=file_menu_r ;
   
   for( i=0 ; i<n_Files ; i++ )
     { 
	 file_menu_r[i].flag=3 ;
	 file_menu_r[i].ret =0 ;
	 file_menu_r[i].funk=read_buch ;
	 file_menu_r[i].data=Files[i] ;
	 file_menu_r[i].next=NULL ;
	 file_menu_r[i].name=Files[i] ;
	 if( 18<=i ) break ;
      }
   file_menu_r[i].flag=3 ;
   file_menu_r[i].ret =0 ;
   file_menu_r[i].funk=f_exit ;
   file_menu_r[i].data=NULL ;
   file_menu_r[i].next=NULL ;
   file_menu_r[i].name=StrExit ;
   i++ ;   
   file_menu_r[i].flag=0 ;
   file_menu_r[i].ret =0 ;
   file_menu_r[i].funk=NULL ;
   file_menu_r[i].data=NULL ;
   file_menu_r[i].next=NULL ;
   file_menu_r[i].name=NULL ;
}
/***************************************************************************/
// ॠ    롨ࠥ ᫮
/***************************************************************************/
void main_loop( void )
{
   char  Str[40]="" ;
   long  i ;

   Buch.i_wort=0 ;
   init_menu(  );
   Buch.read_paragraf( Buch.i_wort );
   while( 1 )
   {  short t1,t2 ;
      malen( Buch.i_wort,Str );
      s_redraw( );
      s_goto_xy( max_Y/2+2,px+1 );
      s_getch( &t1,&t2 );
      switch( t1 )
      {
      case S_key_Back: case S_key_Del:
                       Str[--px]=0 ; break ;
      case '\r':       antwort( Buch.i_wort ); Str[px=0]=0 ; break ;
      case S_key_Esc : break ;
      default:         if( 40<=px ) break ;
		       Str[px++]=t1 ; Str[px]=0 ;
		       i=Buch.find( Str );
		       if( i<0 ) Str[--px]=0 ;
			   else  Buch.i_wort=i ;
		       break ;
      case 0 :
	 switch( t2 )
	 {
	 case S_key_Up:    if( 0<Buch.i_wort ) Buch.i_wort-- ; break ;
	 case S_key_Down:  if( Buch.i_wort<Buch.n_sy_Word ) Buch.i_wort++ ; break ;
	 case S_key_PgUp:  Buch.i_wort-=max_Y/2 ; if( Buch.i_wort<0 ) Buch.i_wort=0 ; break ;
	 case S_key_PgDn:  Buch.i_wort+=max_Y/2 ;
			   if( Buch.n_sy_Word<=Buch.i_wort )
			       Buch.i_wort=Buch.n_sy_Word-1 ;
			   break ;
	 case S_key_F10:   menu();
	 }
	 Buch.read_paragraf( Buch.i_wort );
	 break ;
      }
   }
}
/***************************************************************************/
// ॠ    ᬮ ॢ ࠭ ᫮
/***************************************************************************/
void antwort( long i_wort )
{
   short x=0,y=0 ;
   short t1,t2 ;

   while( 1 )
   {
      malen1( i_wort,x,y );
      s_redraw( );
      s_goto_xy( max_Y/2+2,px+1 );
      s_getch( &t1,&t2 );
      switch( t1 )
      {
      case S_key_Esc : case S_key_Enter : 
         malen1( -1,x,y ); return ;
      case 0 :
	 switch( t2 )
	 {
	 case S_key_Up:    y=max(0 ,y-1); break ;
	 case S_key_Down:  y=min(10,y+1); break ;
	 case S_key_Left:  x=max(0 ,x-1); break ;
	 case S_key_Right: x=min(80,x+1); break ;
	 case S_key_F10:   malen1( -1,x,y ); return ;
	 }
      }
   }
}
/***************************************************************************/
//                      ⮡ࠦ ᯨ᪠ ᫮
/***************************************************************************/
void malen( short i_wort,char *Str )
{  short  i,i1 ;
   long   Begin,FirstWord,off ;
   char  *Str1 ;

   s_get_size( &max_X,&max_Y );
   null_menu( );
   s_rame2_F( 1,0,max_Y-1,max_X-1,0x0f );
   FirstWord=Begin=Buch.i_Paragraf*16 ;
   if( FirstWord<(i_wort-max_Y/2+2) ) FirstWord=(i_wort-max_Y/2+2);

   for( i=0 ; i<max_Y/2 ; i++ )
   {   
       Str1=Buch.wort( FirstWord+i );
       
       Sempty[max_X-2]=0 ;
       s_text_yxf( i+2,1,0x0f,Sempty );
       if( FirstWord+i==i_wort )
       {  s_text_yxf( i+2,1,0xf0,Sempty );
	  s_text_yxf( i+2,1,0xf0,Str1 );
       }
       else s_text_yxf( i+2,1,0x0f,Str1 );
       Sempty[max_X-2]=' ';
   }

   s_rame2_F( max_Y/2+1,0,max_Y/2+3,max_X-1,0x0f );
   s_text_yxf( max_Y/2+2,1,0x0f,Str );
   s_text_yxf( max_Y/2+3,3,0x0f," F10- " );
}
/***************************************************************************/
// ⮡ࠧ ॢ ࠭ ᫮
/***************************************************************************/
void malen1( long i_wort, short x, short y )
{  
   short i,j,j1,s,L ;
   char  *Str,Str1[100] ;
   
   s_get_size( &max_X,&max_Y );
       malen( i_wort,"" );
   Sempty[max_X-2]=0 ;
   for( i=0 ; i<max_Y/2-5 ; i++ )
       s_text_yxf( max_Y/2+4+i,1,0x0f,Sempty );
   Sempty[max_X-2]=' ' ;
   if( i_wort<0 ) return ;

   Str=Buch.answer( i_wort );
   L=strlen( Str );
   for( i=0,s=j=j1=0 ; i<L ; i++ )
   {  if( Str[i]=='\n' || i==L-1 )
      {  Str1[j++]=0;
	 if( y<=s && s-y<max_Y/2-4 ) 
	     s_text_yxf( max_Y/2+4+s-y,1,0x0f,Str1 );
	 j=j1=0 ; s++ ;
      }
      else
      {  if( (j1++)<x || max_X-3<j ) continue ;
	 Str1[j++]=Str[i] ;
      }
   }
}
/***************************************************************************/
void read_buch( void *Str )
{  short i,i_Dict=0 ;
   char  Name[200] ;

   strcpy( Name,StartPath );
   strcat( Name,(char *)Str );
   Buch.make( Name );
   
   for( i=0 ; i<n_Files ; i++ )
      if( 0==strcmp(Files[i],(char *)Str) ) 
      {   i_Dict=i+1 ; break ;  }
   Buch.set_divider( Stande1.Dict[i_Dict].Divider );
}
/***************************************************************************/
void t_Stande1::init( void )
{  short i,i1 ;

   Dict=(t_DictStande *)Calloc( n_Files+1,sizeof(t_DictStande));
   for( i=0 ; i<=n_Files ; i++ )
   {
      strcpy( Dict[i].Divider,"=" );
      Dict[i].fTrans=0 ;
      for( i1=0 ; i1<5 ; i1++ )
         Dict[i].Text[i1].color=0xf0 ;
   }
}
/***************************************************************************/
/*                        ஥ 䠩                         */
/***************************************************************************/
char t_Stande1::read1( void )
{
   char  *h,*Val ;
   char   File[200],Var[200],Prefix[50] ;

   File[0]=0 ;
   h=getenv( "HOME" );
   if( h!=NULL ) strcpy( File,h );
   strcat( File,"/.slowo.ini" );

   if( 0!=load_rcfile( File, "" ) ) return -1 ;

   Val=get_value( "Path" );
   if( Val!=NULL ) strcpy( StartPath,Val ) ;
   return 0 ;
}
/***************************************************************************/
void t_Stande1::read2( void )
{
   short  i,i1,L ;
   char  *h,*Val ;
   char   File[200],Var[200],Prefix[50] ;

   for( i=0 ; i<=n_Files ; i++ )
   {
      if( i==0 ) strcpy( Prefix,"" );
      else
      {  strcpy( Prefix,Files[i-1] );
	 L=strlen( Prefix );
	 Prefix[L-4]=':' ; Prefix[L-3]=0 ;
      }
      if( i!=0 ) Dict[i]=Dict[0] ;

      sprintf( Var,"%s%s",Prefix,"List.Color" );
      Val=get_value( Var );
      if( Val!=NULL ) Dict[i].Text[1].color=tcolor(Val);

      sprintf( Var,"%s%s",Prefix,"Word.Color" );
      Val=get_value( Var );
      if( Val!=NULL ) Dict[i].Text[2].color=tcolor(Val);

      sprintf( Var,"%s%s",Prefix,"Translate.Color" );
      Val=get_value( Var );
      if( Val!=NULL ) Dict[i].Text[4].color=tcolor(Val);

      sprintf( Var,"%s%s",Prefix,"Divider" );
      Val=get_value( Var );
      if( Val!=NULL ) strcpy( Dict[i].Divider,Val );
   }
}
/* ----------------------------------------------------------------------- */
void  t_Stande1:: write( void )
{
   short  i,i1,L ;
   char  *h ;
   FILE  *fw ;
   char   File[200],Prefix[50]="" ;

   File[0]=0 ;
   h=getenv( "HOME" );
   if( h!=NULL ) strcpy( File,h );
   strcat( File,"/.slowo.ini" );

   fw=Fopen( File,"w" );
   
   fprintf( fw,"Path %s",StartPath );

   for( i=0 ; i<=n_Files ; i++ )
   {
      if( i!=0 )
      {  strcpy( Prefix,Files[i-1] );
	 L=strlen( Prefix );
	 Prefix[L-4]=0 ;
	 fprintf( fw,"\n%s\n{",Prefix );
	 Prefix[L-4]=':' ; Prefix[L-3]=0 ;
      }

      fprintf( fw,"\nList.Color       0x%02x",Dict[i].Text[1].color&0x0ff );
      fprintf( fw,"\nWord.Color       0x%02x",Dict[i].Text[2].color&0x0ff );
      fprintf( fw,"\nTranscript.Color 0x%02x",Dict[i].Text[3].color&0x0ff );
      fprintf( fw,"\nTranslate.Color  0x%02x",Dict[i].Text[4].color&0x0ff );

      fprintf( fw,"\nDivider          \"%s\"",Dict[i].Divider );
      fprintf( fw,"\nTranslate        %d",Dict[i].fTrans );

      if( i!=0 )
      {   fprintf( fw,"\n}" );  }
   }

   fclose( fw );
}
/****************************************************************************/
short tcolor( char *str )
{  short f1=0,f2=7 ;

   if( str[0]!='0' || str[1]!='x' ) return -1 ;
   if( '0'<=str[2] && str[2]<='9' ) f1=str[2]-'0' ;
   if( 'a'<=str[2] && str[2]<='f' ) f1=str[2]-'a'+10 ;
   if( 'A'<=str[2] && str[2]<='F' ) f1=str[2]-'A'+10 ;
   if( '0'<=str[3] && str[3]<='9' ) f2=str[3]-'0' ;
   if( 'a'<=str[3] && str[3]<='f' ) f2=str[3]-'a'+10 ;
   if( 'A'<=str[3] && str[3]<='F' ) f2=str[3]-'A'+10 ;
   return (f1<<4)+f2 ;
}
/****************************************************************************/
void  f_exit( void *V )
{  s_end_schone() ;
   exit(0);  
}
