/****************************************************************************
   This is a part of programm of Dictionary for UNIX
   Copyright (C) 1999 Anisimow Dmitry.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/
# include <stdio.h>
# include <malloc.h>
# include <string.h>

# include "mylib.h"
# include "t_schone.h"
# include "menu.h"

//# define _SUN_
// --------- ᠭ 梥⮢ ------
# define   h_menu_Farbe  0xf0
# define   h_curs_Farbe  0x1f
# define   v_menu_Farbe  0xf0
# define   v_curs_Farbe  0x1f

// ------------------ ᠬ  --------------------------
MENU *file_menu_r ;

MENU vorsage_menu_r[] =
{ // { 3,0,Forsage       ,(void *)" ணࠬ" ,NULL," ணࠬ" },
   { 3,0,Forsage  ,NULL ,NULL," ணࠬ" },
   { 0,0,NULL     ,NULL ,NULL,NULL          }
};
MENU wort_menu_r[] =
{  { 2,0,NULL,NULL,file_menu_r   ,""  },
   { 2,0,NULL,NULL,vorsage_menu_r,"᪠"},
   { 0,0,NULL,NULL,NULL          ,NULL       }
};

# define stop() {  short key1,key2 ; s_getch(&key1,&key2); }

/* -----------------    --------------- */
typedef struct
{  short size_x,size_y,
	 n_punkt,
	 *igrek ;
   MENU  *menu ;
}  form ;

static   short  *mass_iks, *mass_igrek ;
static   char    Exist=0 ;

/* ----------------------------------------------------------------------- */

void   menu( void ) ;
void   init_menu( void ) ;
short  hor_menu( short igrek, MENU *menu ) ;
void   s_hor_menu( short igrek, short *iks,MENU *menu ) ;
void   s_ver_menu( short igrek, short iks,form F ) ;
void   p_hor_menu( short y,short x,char *name ) ;
void   p_ver_menu( short y,short x,form f,short cur ) ;
short  ver_menu( short y,short x, MENU *menu ) ;
void   ver_menu_creat( form *f, MENU *menu ) ;
void   ver_menu_delet( form *f ) ;
short  sehen_hor_menu( short **iks,MENU *menu ) ;
static short  schnell_taste( MENU *menu,uchar taste ) ;
void   sorry( short y, short x );

/* *********************************************************************** */
void menu( void )
{   short c ;
    if( Exist==0 ) init_menu( );
    hor_menu( 0, wort_menu_r ) ;
}
/* ------------ 墠    -------------------------------- */
void init_menu( void )
{
    mass_iks   = (short *)Calloc( 25,sizeof(short) ) ;
    mass_igrek = (short *)Calloc( 25,sizeof(short) ) ;
    Exist=1 ;
}
/* ----------- ᮢ ,  ஬  ࠭   㭪 -------- */
void null_menu( void )
{  short *iks ;

   if( Exist==0 ) init_menu( );
   sehen_hor_menu( &iks,wort_menu_r ) ;
   s_hor_menu( 0,iks,wort_menu_r ) ;
}
/* ------------ ॠ     孥 ஢ ----------------*/
short hor_menu( short igrek, MENU *menu )
{  short punkt=0,flag=0 ;
   static short key1,key2,key3 ;
   short size_Menu ;
   short *iks ;

   size_Menu=sehen_hor_menu( &iks,menu ) ;
   while( 1 )
   {
       s_hor_menu( igrek,iks,menu ) ;
       p_hor_menu( igrek,iks[punkt],menu[punkt].name ) ;

       key1=0 ; key2=0 ; key3=0 ;

       s_getch( &key1,&key2) ;

       switch( key2 )
       {   case S_key_Left: M_LINKS :
		if( punkt<=0 ) punkt=size_Menu-1 ; else punkt-- ;
		if( flag==1 && menu[punkt].flag==F_MENU )
		{   s_hor_menu( igrek,iks,menu );
		    p_hor_menu( igrek,iks[punkt],menu[punkt].name ) ;
		    key3=ver_menu( 1,iks[punkt], menu[punkt].next ) ;
		}
		else
		{  key3=0 ; }
		break ;
	   case S_key_Right: M_RECHTS :
		if( punkt>=size_Menu-1 ) punkt=0 ; else punkt++ ;
		if( flag==1 && menu[punkt].flag==F_MENU )
		{   s_hor_menu( igrek,iks,menu );
		    p_hor_menu( igrek,iks[punkt],menu[punkt].name ) ;
		    key3=ver_menu( 1,iks[punkt], menu[punkt].next ) ;
		}
		else
		{  key3=0 ; }
		break ;
	   case 0 :
	   switch( key1 )
	   {
		schnell :
		    s_hor_menu( igrek,iks,menu );
		    p_hor_menu( igrek,iks[punkt],menu[punkt].name ) ;
		case '\r' :
		   if( menu[punkt].flag==4 ){ return S_key_Esc ; }
		   if( menu[punkt].flag==3 )
		   {   menu[punkt].funk( menu[punkt].data ) ;
		      return S_key_Esc ;
		   }
		   if( menu[punkt].flag==2 )
		   {   flag=1 ;
		       key3=ver_menu( 1,iks[punkt], menu[punkt].next ) ;
		   }
		   break ;
	       case S_key_Esc : return S_key_Esc ;
	       default :
		   {   short p1 ;
		       p1=schnell_taste( menu,key1 ) ;
		       if( 0<=p1 ) {  punkt=p1 ; goto schnell ;  }
		   }
		   break ;
	   }
       }
       switch( key3 )
       {   case S_key_Left : goto M_LINKS ;
	   case S_key_Right: goto M_RECHTS ;
	   case S_key_Esc  : return S_key_Esc ;
       }
   }
}
/* --------------- ॠ    믠饣  ----------------- */
short ver_menu( short y,short x, MENU *menu )
{  short punkt=0,ret ;
   static short key1,key2 ;
   form  f ;
   short i ;

   ver_menu_creat( &f,menu ) ;
   
# if !defined(_SUN_) && !defined(__QNX__)
   s_save( y,x,y+f.size_y+1,x+f.size_x+1 );
# else   
   s_save( y,x-1,y+f.size_y+1,x+f.size_x+2 );
# endif

   while( 1 )
   {
       s_ver_menu( 1,x,f ) ;
       p_ver_menu( 1,x,f,punkt ) ;

       s_getch( &key1,&key2 ) ;

       switch( key2 )
       {   case S_key_Up:
		if( punkt<=0 ) punkt=f.n_punkt-1 ; else punkt-- ; break ;
	   case S_key_Down:
		if( punkt>=f.n_punkt-1 ) punkt=0 ; else punkt++ ; break ;
	   case S_key_Left : ret = S_key_Left ;   goto ENDE ;
	   case S_key_Right: ret = S_key_Right ;  goto ENDE ;
	   case 0 :
	       switch( key1 )
	       {   case '\r' :
	   schnell :   i=f.igrek[punkt] ;
		       if( menu[i].flag==4 ){  ret = S_key_Esc ;  goto ENDE ; }
		       if( menu[i].flag==3 )
		       {   s_restore( ) ;
			   menu[i].funk( menu[i].data ) ;
			   ret = S_key_Esc ;  goto ENDE1 ;
		       }
		       if( menu[i].flag==2 )
		       {   ver_menu( i,x, menu[punkt].next ) ;
			   break ;
		       }
		   default :
		       {   short p1 ;
			   p1=schnell_taste( menu,key1 ) ;
			   if( 0<=p1 ) {  punkt=p1 ; goto schnell ;  }
		       }   break ;
	       }
	   case S_key_Esc : ret = S_key_Esc ; goto ENDE ;
       }
   }
ENDE :  s_restore( ) ;
ENDE1 : ver_menu_delet( &f ) ;
   return ret ;
}
/* ------------- ।   ------------------------------ */
short schnell_taste( MENU *menu,uchar taste )
{  short i,j ;
   uchar c ;

   for( i=0 ; menu[i].flag!=0 ; i++ )
   {   for( j=0 ; ; j++ )
       {   c=menu[i].name[j] ;
	   if( c==0 ) break ;
	   if( (uchar)'Ā'<=c && c<=(uchar)'' )
	   {   if( c==taste ) return i ;
	       //if( XLAT[c]==XLAT[taste] ) return i ;
	       break ;
	   }
       }
   }
   return -1 ;
}
/* ----------------------------------------------------------------------- */
short sehen_hor_menu( short **iks,MENU *menu )
{  short i,i1,j ;
   short *a ;

   *iks=a = mass_iks ;
   for( j=2,i=0 ; ; i++ )
   {  if( menu[i].flag==0 ) break ;
      a[i]=j ;
      for( i1=0 ; i1<20 ; i1++ )
	 if( menu[i].name[i1]==0 ) break ;
      j+=i1+2 ;
   }
   return i ;
}
/* ----------------------------------------------------------------------- */
void s_hor_menu( short igrek, short *iks, MENU *menu )
{  short i ;

   s_text_yxf( igrek,0,h_menu_Farbe,
   "                                                                              " ) ;
   for( i=0 ; i<25 ; i++ )
   {  if( menu[i].flag==0 ) break ;
      s_text_yxf( igrek,iks[i],h_menu_Farbe,menu[i].name ) ;
   }
}
/* ----------------------------------------------------------------------- */
void s_ver_menu( short igrek, short iks, form F )
{  short i ;

# if !defined(_SUN_) && !defined(__QNX__)
   s_rame1_f( igrek,iks,igrek+F.size_y+1,iks+F.size_x+1,v_menu_Farbe ) ;
# else   
   s_rame1_F( igrek,iks-1,igrek+F.size_y+1,iks+F.size_x+2,v_menu_Farbe ) ;
# endif
   
   for( i=0 ; i<F.size_y ; i++ )
   {  s_text_yxf( igrek+1+i,iks+1,v_menu_Farbe,F.menu[i].name ) ;  }
}
/* -------- ᮢ 믠饥  ----------------------------------- */
void p_ver_menu( short y,short x,form F,short cur )
{  short yy ;
   char *name ;

   yy=y+F.igrek[cur]+1 ;
   name=F.menu[F.igrek[cur]].name ;
# if !defined(_SUN_) && !defined(__QNX__)
   s_text_yxf( yy,x+1,v_curs_Farbe,name ) ;
# else   
   s_text_yxf( yy,x,v_curs_Farbe,"<" ) ;
   s_text_yxf( yy,x+1,v_curs_Farbe,name ) ;
   s_text_yxf( yy,x+1+strlen(name),v_curs_Farbe,">" ) ;
# endif
}
/* ----------------------------------------------------------------------- */
void ver_menu_creat( form *f, MENU *menu )
{  short i,i1,j,s,*igrek ;

   for( i=0 ; i<25 ; i++ ) if( menu[i].flag==0 ) break ;
   f->size_y=i ;

   igrek = mass_igrek ;
   for( s=j=0,i=0 ; i<f->size_y ; i++ )
   {  if( menu[i].flag==0 ) break ;
      for( i1=0 ; i1<25 ; i1++ )
	 if( menu[i].name[i1]==0 ) break ;
      if( i1>s ) s=i1 ;
      if( menu[i].flag==2 || menu[i].flag==3 || menu[i].flag==4 )
	  igrek[j++]=i ;
   }
   f->size_x=s ;     f->n_punkt=j ;
   f->igrek=igrek ;  f->menu=menu ;
}
/* ----------------------------------------------------------------------- */
void ver_menu_delet( form *f )
{  ; }
/* ----------------------------------------------------------------------- */
void p_hor_menu( short y,short x,char *name )
{
# if !defined(_SUN_) && !defined(__QNX__)
   s_text_yxf( y,x,h_curs_Farbe,name ) ;
# else   
   s_text_yxf( y,x-1,h_curs_Farbe,"<" ) ;
   s_text_yxf( y,x,h_curs_Farbe,name ) ;
   s_text_yxf( y,x+strlen(name),h_curs_Farbe,">" ) ;
# endif   
}
/* ----------------------------------------------------------------------- */
void Sorry( void *d ){   sorry( 6,4 ) ;  }
/* ----------------------------------------------------------------------- */
void sorry( short y, short x )
{
   s_save( y,x,y+4,x+20 ) ;
   s_rame1_f( y,x,y+4,x+20,0x70 ) ;
   s_text_yxf( y+1,x+1,0x70,"  ,     ") ;
   s_text_yxf( y+2,x+1,0x70,"   㭪      ") ;
   s_text_yxf( y+3,x+1,0x70,"    ॠ  ") ;

   stop( ) ;
   s_restore( ) ;
}
/* ----------------------------------------------------------------------- */
void Forsage( void *d )
{
   short y,x,max_Y,max_X ;
   
   s_get_size( &max_X,&max_Y );
   y=max_Y/2-3 ; x=max_X/2-10 ;
   s_save( y,x,y+5,x+20 ) ;
   s_rame1_f( y,x,y+5,x+20,0x70 ) ;
   s_text_yxf( y+1,x+1,0x70,"    ") ;
   s_text_yxf( y+2,x+1,0x70,"   ᨬ  ..  ") ;
   s_text_yxf( y+3,x+1,0x70,"qnx port sergey prozhogin") ;
   s_text_yxf( y+4,x+1,0x70,"20 ᥭ 1999 .") ;
   s_text_yxf( y+5,x+1,0x70,"⠩  readme.txt") ;
   stop( ) ;
   s_restore( ) ;
}


