# ifndef MYLIB_H
# define MYLIB_H

# include <stdio.h>
# include <malloc.h>
#ifdef __QNX__
# include <string.h>
#endif

# ifdef __TC__
   # define try
   # define catch( A )  A=0;
   # define throw( A )  A
   # define max(a,b)    (((a) > (b)) ? (a) : (b))
   # define min(a,b)    (((a) < (b)) ? (a) : (b))
# endif

# define    Free( a )    if( a!=NULL ) {  free(a);   a=NULL ;  }
# define    Fclose( f )  if( f!=NULL ) {  fclose(f); f=NULL ;  }

void  *Calloc( long N, long S );
void  *Malloc( long N, long S );
void  *Realloc( void *M, long L );

FILE  *Fopen( char *Name, char *a );
void   Fread( void *M, long S, long N, FILE *File );
void   Fwrite( void *M, long S, long N, FILE *File );
void   Fseek( FILE *fw, long Offset, long Mode );
long   FileLength( FILE *fw );
void koi8tocp866( char *koi );

# endif
