/****************************************************************************
   This is a part of programm of Dictionary for UNIX
   Copyright (C) 1999 Anisimow Dmitry.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/
#ifndef S_KEY_DEFINED
#define S_KEY_DEFINED

   #define S_key_F1   59
   #define S_key_F2   60
   #define S_key_F3   61
   #define S_key_F4   62
   #define S_key_F5   63
   #define S_key_F6   64
   #define S_key_F7   65
   #define S_key_F8   66
   #define S_key_F9   67
   #define S_key_F10  68

/* ---------- ࠢ, ஢ ----------- */
   #define S_key_Esc    27
   #define S_key_Enter '\r'
   #define S_key_TabL   3840
   #define S_key_TabR   '\t'
   #define S_key_Back   8
   #define S_key_Ins    82
   #define S_key_Del    83
   #define S_key_Home   71
   #define S_key_End    79
   #define S_key_PgUp   73
   #define S_key_PgDn   81
   #define S_key_Left   75
   #define S_key_Right  77
   #define S_key_Up     72
   #define S_key_Down   80
   
      #define S_key_Ctrl_Ins    146
      #define S_key_Ctrl_Del    147
      #define S_key_Ctrl_Home   119
      #define S_key_Ctrl_End    117
      #define S_key_Ctrl_PgUp   132
      #define S_key_Ctrl_PgDn   118
      #define S_key_Ctrl_Left   115
      #define S_key_Ctrl_Right  116
      #define S_key_Ctrl_Up     141
      #define S_key_Ctrl_Down   145

      #define S_key_Alt_Ins     162
      #define S_key_Alt_Del     163
      #define S_key_Alt_Home    200   
      #define S_key_Alt_End     159   
      #define S_key_Alt_PgUp    153   
      #define S_key_Alt_PgDn    161   
      #define S_key_Alt_Left    155
      #define S_key_Alt_Right   157
      #define S_key_Alt_Up      152
      #define S_key_Alt_Down    160

   #define S_Shift_L  0x20
   #define S_Ctrl_L   0x10
   #define S_Alt_L    0x08
   #define S_Alt_R    0x04
   #define S_Ctrl_R   0x02
   #define S_Shift_R  0x01

# endif


