# include <malloc.h>
# include <string.h>
# include <curses.h>
# include <s_defkey.h>
# include <t_schone.h>

# define max(a,b)    (((a) > (b)) ? (a) : (b))
# define min(a,b)    (((a) < (b)) ? (a) : (b))

# define  DEFAULT 0
# define  XTERM   1
# define  NXTERM  2
# define  RXVT    3
# define  CONSOLE 4
# define  SUN     5

//class t_Screen
//{
   long  *Symbol ;
   uchar *Color ;
   short  max_x,max_y ;
   short  size_x,size_y ;
   char   TermName[40] ;
   char   TermType ;
   char   f_Color ;
//} ;

class t_Save_Screen
{  long   *stek ;   //  ⥩ ࠭
   short   l_stek ; //  ᨢ Stek
   short   j_stek ; // 㪠⥫ ᫥ ᢮ 
public:
   t_Save_Screen( short l );
   ~t_Save_Screen( void );
   void   save   ( short y1, short x1, short y2, short x2 );
   void   save_rame( short y1, short x1, short y2, short x2 );
   void   restore( void );
} ;

# if !defined(_SUN_) && !defined(__QNX__)
   mmask_t     mm ;
# endif

WINDOW     *Win ;
short       Cur_X=0,Cur_Y=0 ;
t_Save_Screen  Save( 10000 ) ;

void s_rame( short y1, short x1, short y2, short x2, uchar f );
void s_quadro( short y1, short x1, short y2, short x2, uchar f );

/***************************************************************************/
void   s_begin_schone( void )
{  short i,i1 ;

   max_x=160 ; max_y=64 ;
   Symbol=(long  *)calloc( max_x*max_y,sizeof(long) );
   Color =(uchar *)calloc( max_x*max_y,1 );
   for( i=0 ; i<max_x*max_y ; i++ )
      Symbol[i]=' ';

   Win=initscr();
   noecho( );
   keypad( Win, TRUE );
   strcpy( TermName,termname() );

   TermType=DEFAULT ;
   if( 0==strncmp( TermName,"xterm"  ,5) )   TermType=XTERM ; //!!
   if( 0==strncmp( TermName,"nxterm" ,6) )   TermType=NXTERM ;
   if( 0==strncmp( TermName,"rxvt"   ,4) )   TermType=RXVT ;
   if( 0==strncmp( TermName,"linux"  ,5) )   TermType=CONSOLE ; //!!
   if( 0==strncmp( TermName,"cmdtool",7) )   TermType=SUN ;
   //printf( "NameTerm = %s\n",TermName );

   getmaxyx( Win, size_y, size_x );

# if !defined(_SUN_) && !defined(__QNX__)

   mousemask( ALL_MOUSE_EVENTS,&mm );
   f_Color=has_colors();

   if( f_Color!=0 )
   {
      start_color();
      long Color[8] ;
      Color[0]=COLOR_BLACK ;
      Color[1]=COLOR_BLUE ;
      Color[2]=COLOR_GREEN ;
      Color[3]=COLOR_CYAN ;
      Color[4]=COLOR_RED ;
      Color[5]=COLOR_MAGENTA ;
      Color[6]=COLOR_YELLOW ;
      Color[7]=COLOR_WHITE ;

      for( i=0 ; i<8 ; i++ )
	 for( i1=0 ; i1<8 ; i1++ )
	    init_pair( 1+8*i1+i,Color[i],Color[i1] );
   }
# endif
}
/* ----------------------------------------------------------------------- */
void   s_begin_schone( int argc, char *argv[] )
{  s_begin_schone( );  }
/* ----------------------------------------------------------------------- */
void   s_end_schone( void )
{  endwin();  }
/* ----------------------------------------------------------------------- */
void   s_nacht( void )
{  long i ;

   for( i=0 ; i<max_x*max_y ; i++ )
      Symbol[i]=Color[i]=0 ;
}
/* ----------------------------------------------------------------------- */
void   s_get_size( short *sx, short *sy )
{  short size_y1, size_x1 ;

   getmaxyx( Win, size_y1, size_x1 );
   if( max_x<size_x1 ) size_x1=max_x ;
   if( max_y<size_y1 ) size_y1=max_y ;
   *sx=size_x1 ; *sy=size_y1 ;
   size_x=size_x1 ; size_y=size_y1 ;
}
/* ----------------------------------------------------------------------- */
void   s_text_yxf(  short y, short x, uchar f, char *str )
{  short i,r1 ;

   r1=max_x*y+x ;
   for( i=0 ; str[i]!=0 && str[i]!='\r' && str[i]!='\n' ; i++ )
   {  Symbol[ r1+i ]=str[i] ;
      Color [ r1+i ]=f ;
   }
}
/* ----------------------------------------------------------------------- */
void   s_text_yxf1( short y, short x, uchar f, char *str )
{  short i,r ;

   r = max_x*y+x ;
   Symbol[ r ] = '\"' ; Color[ r ] = f ;
   for( i=0 ; str[i]!=0 ; i++ )
   {  r=max_x*y+x+i+1 ;
      Symbol[ r ] = str[i] ; Color[ r ] = f ;
   }
   r=r+2 ;
   Symbol[ r ] = '\"' ; Color[ r ] = f ;
}
/* ----------------------------------------------------------------------- */
void   s_text_yxfl( short y, short x, uchar f, short L, char *str )
{  short i,r1 ;

   r1=max_x*y+x ;
   for( i=0 ; str[i]!=0 && i<L ; i++ )
   {  Symbol[ r1+i ]=str[i] ;
      Color [ r1+i ]=f ;
   }
}
/* ----------------------------------------------------------------------- */
void   s_text_yx( short y, short x, char *str )
{  short i,r1 ;

   r1=max_x*y+x ;
   for( i=0 ; str[i]!=0 ; i++ )
      Symbol[ r1+i ]=str[i] ;
}
/* ----------------------------------------------------------------------- */
void   s_farbe_yxt( short y, short x, uchar *t, char *str )
{  short i,r1,r2,f ;
   uchar c ;

   r1=max_x*y+x ;
   for( i=0 ; str[i]!=0 ; i++ )
   {  f=0x07 ; r2=str[i] ;
      if( '0'<=r2 && r2<= '9' ) f=t[r2-'0'] ;
      if( 'a'<=r2 && r2<= 'z' ) f=t[r2-'a'+10] ;
      Color[ r1+i ]=f ;
   }
}
/* ----------------------------------------------------------------------- */
void   s_rame1_f( short y1, short x1, short y2, short x2, uchar f )
{
   s_rame( y1, x1, y2, x2, f );
}
/* ----------------------------------------------------------------------- */
void   s_rame1_F( short y1, short x1, short y2, short x2, uchar f )
{
   s_quadro( y1, x1, y2, x2, f );
   s_rame  ( y1, x1, y2, x2, f );
}
/* ----------------------------------------------------------------------- */
void   s_rame2_f( short y1, short x1, short y2, short x2, uchar f )
{
   s_rame  ( y1, x1, y2, x2, f );
}
/* ----------------------------------------------------------------------- */
void   s_rame2_F( short y1, short x1, short y2, short x2, uchar f )
{
   s_quadro( y1, x1, y2, x2, f );
   s_rame  ( y1, x1, y2, x2, f );
}
/* ----------------------------------------------------------------------- */
void s_rame( short y1, short x1, short y2, short x2, uchar f )
{  short i,r ;

   for( i=x1+1 ; i<x2 ; i++ )
   {  r=max_x*y1+i ; Symbol[ r ]=ACS_HLINE ; Color[ r ]=f ;
      r=max_x*y2+i ; Symbol[ r ]=ACS_HLINE ; Color[ r ]=f ;
   }
   for( i=y1+1 ; i<y2 ; i++ )
   {  r=max_x*i+x1 ; Symbol[ r ]=ACS_VLINE ; Color[ r ]=f ;
      r=max_x*i+x2 ; Symbol[ r ]=ACS_VLINE ; Color[ r ]=f ;
   }
   r=max_x*y1+x1 ; Symbol[ r ]=ACS_ULCORNER ; Color[ r ]=f ;
   r=max_x*y2+x1 ; Symbol[ r ]=ACS_LLCORNER ; Color[ r ]=f ;
   r=max_x*y1+x2 ; Symbol[ r ]=ACS_URCORNER ; Color[ r ]=f ;
   r=max_x*y2+x2 ; Symbol[ r ]=ACS_LRCORNER ; Color[ r ]=f ;
}
/* ----------------------------------------------------------------------- */
void s_quadro( short y1, short x1, short y2, short x2, uchar f )
{  short i,j,r1 ;

   for( j=y1+1 ; j<y2 ; j++ )
   {  for( i=x1+1 ; i<x2 ; i++ )
      {   r1=max_x*j+i ;
	  Symbol[ r1 ]=' ' ;
	  Color [ r1 ]=f ;
      }
   }
}
/* ----------------------------------------------------------------------- */
void s_save_rame( short s1, short p1, short s2, short p2 )
{  Save.save_rame( s1, p1, s2, p2 );  }

void s_save( short s1, short p1, short s2, short p2 )
{  Save.save( s1, p1, s2, p2 );  }

void s_restore( void )
{  Save.restore( );  }
/* ----------------------------------------------------------------------- */
t_Save_Screen :: t_Save_Screen( short L )
{
   stek=(long *)calloc( L,sizeof(long) );
   if( stek==NULL ) throw( -1 );
   j_stek=0 ;
   l_stek=L ;
}
/* ----------------------------------------------------------------------- */
t_Save_Screen :: ~t_Save_Screen( void )
{
   if( stek!=NULL ){  free( stek ); stek=NULL ;  }
   j_stek=0 ;
   l_stek=0 ;
}
/* ----------------------------------------------------------------------- */
void t_Save_Screen :: save( short y1, short x1, short y2, short x2 )
{  short i,j,r ;

   for( i=y1 ; i<=y2 ; i++ )
   {  for( j=x1 ; j<=x2 ; j++ )
      {   r=max_x*i+j ;
	  stek[j_stek++] = Color [ r ] ; /* ਡ */
	  stek[j_stek++] = Symbol[ r ] ;   /* ᨬ  */
      }
   }
   stek[j_stek++]=(uchar )x1 ; stek[j_stek++]=(uchar )y1 ;
   stek[j_stek++]=(uchar )x2 ; stek[j_stek++]=(uchar )y2 ;
   stek[j_stek++]=0 ;
}
/* ----------------------------------------------------------------------- */
void t_Save_Screen :: save_rame( short s1, short p1, short s2, short p2 )
{  short i,r,r1,r2 ;

   r1=max_x*s1 ; r2=max_x*s2 ;
   for( i=p1 ; i<=p2 ; i++ )
   {  r=r1+i ;
      stek[j_stek++]=Symbol[ r ] ;
      stek[j_stek++]=Color [ r ] ;
      r=r2+i ;
      stek[j_stek++]=Symbol[ r ] ;
      stek[j_stek++]=Color [ r ] ;
   }
   for( i=s1 ; i<=s2 ; i++ )
   {  r1=max_x*i+p1 ;
      stek[j_stek++]=Symbol[ r1 ] ;
      stek[j_stek++]=Color [ r1 ] ;
      r2=max_x*i+p2 ;
      stek[j_stek++]=Symbol[ r2 ] ;
      stek[j_stek++]=Color [ r2 ] ;
   }
   stek[j_stek++]=(uchar )p1 ; stek[j_stek++]=(uchar )s1 ;
   stek[j_stek++]=(uchar )p2 ; stek[j_stek++]=(uchar )s2 ;
   stek[j_stek++]=1 ;
}
/* ----------------------------------------------------------------------- */
void t_Save_Screen :: restore( void )
{  short i,j,p1,p2,s1,s2,
	 r,r1,r2 ;
   uchar c,f ;

   f =stek[--j_stek] ;
   s2=stek[--j_stek] ; p2=stek[--j_stek] ;
   s1=stek[--j_stek] ; p1=stek[--j_stek] ;
   if( f==1 )
   {  for( i=s2 ; s1<=i ; i-- )
      {  r=max_x*i+p2 ;
	 f=Color [ r ] = stek[--j_stek] ;
	 c=Symbol[ r ] = stek[--j_stek] ;
	 r=max_x*i+p1 ;
	 f=Color [ r ] = stek[--j_stek] ;
	 c=Symbol[ r ] = stek[--j_stek] ;
      }
      r1=max_x*s1 ; r2=max_x*s2 ;
      for( i=p2 ; p1<=i ; i-- )
      {  r=r2+i ;
	 f=Color [ r ] = stek[--j_stek] ;
	 c=Symbol[ r ] = stek[--j_stek] ;
	 r=r1+i ;
	 f=Color [ r ] = stek[--j_stek] ;
	 c=Symbol[ r ] = stek[--j_stek] ;
      }
   }
   else
   {  for( i=s2 ; s1<=i ; i-- )
	 for( j=p2 ; p1<=j ; j-- )
	 {   r=max_x*i+j ;
	     c=Symbol[ r ] = stek[--j_stek] ; /* ᨬ  */
	     f=Color [ r ] = stek[--j_stek] ; /* ਡ */
	 }
   }
}
/* ----------------------------------------------------------------------- */
void   s_redraw( void )
{  
	short x,y,r ;
	char  Str[200] ;
	uchar f ;

	for( y=0 ; y<size_y ; y++ )
	{
		r=max_x*y ;
		move( y,0 );
		for( x=0 ; x<size_x ; x++ )
		{  
			f=Color[r+x] ;
#if !defined(_SUN_) && !defined(__QNX__)
			color_set( 1+(f&0x07)+((f&0x70)>>1) ,NULL );
#endif
			if( 256<=Symbol[r+x] )
			{   
				addch( Symbol[r+x] );
			} else
			{   
				Str[0]=Symbol[r+x] ;
				Str[1]=0 ;
				addstr( Str );
			}
		}
//		refresh();
	}
	move( Cur_Y,Cur_X );
}
/* ----------------------------------------------------------------------- */
void   s_goto_xy( short y, short x )
{
   Cur_X=x ; Cur_Y=y ;
}
/* ----------------------------------------------------------------------- */
void   s_getch( short *key1, short *key2 )
{  short key ;

   s_redraw( );
   key=wgetch( Win );
   //printf( " %s %d ",TermName, key );
   if( key== 10 ) {  *key1=S_key_Enter ; *key2=0 ; return ;  }
   if( key==127 ) {  *key1=0 ; *key2=S_key_Del ; /* printf("S_key_Del " ); */ return ;  }
   if( key <256 ) {  *key1=key ; *key2=0 ; return ;  }

   *key1=0 ;
   switch( key )
   {  case 259 : *key2=S_key_Up   ; /* printf("S_key_Up   " ); */ break ;
      case 258 : *key2=S_key_Down ; /* printf("S_key_Down " ); */ break ;
      case 260 : *key2=S_key_Left ; /* printf("S_key_Left " ); */ break ;
      case 261 : *key2=S_key_Right; /* printf("S_key_Right" ); */ break ;
      case 265 : *key2=S_key_F1   ; break ;
      case 266 : *key2=S_key_F2   ; break ;
      case 267 : *key2=S_key_F3   ; break ;
      case 268 : *key2=S_key_F4   ; break ;
      case 269 : *key2=S_key_F5   ; break ;
      case 270 : *key2=S_key_F6   ; break ;
      case 271 : *key2=S_key_F7   ; break ;
      case 272 : *key2=S_key_F8   ; break ;
      case 273 : *key2=S_key_F9   ; break ;
      case 274 : *key2=S_key_F10  ; break ;
      case 331 : *key2=S_key_Ins  ; /* printf("S_key_Ins  " ); */ break ;
    //case 331 : *key2=S_key_Ins  ; /* printf("S_key_Ins  " ); */ break ;
      case 339 : *key2=S_key_PgUp ; /* printf("S_key_PgUp " ); */ break ;
      case 338 : *key2=S_key_PgDn ; /* printf("S_key_PgDn " ); */ break ;
      case 263 : *key1=S_key_Back ; *key2=0 ; break ;
      // rxvt
      case 362 : *key2=S_key_Home ; /* printf("S_key_Home" ); */ break ;
      case 385 : *key2=S_key_End  ; /* printf("S_key_End " ); */ break ;
      case 330 : *key2=S_key_Del  ; /* printf("S_key_Del " ); */ break ;

      default: *key2=0 ;
   }
}


